name: CI

on:
  push:
    branches:
      - master
  pull_request:

jobs:
  build-lowest-version:
    name: Build lowest version
    runs-on: ubuntu-22.04

    steps:
      - name: Set up PHP
        uses: shivammathur/setup-php@v2
        with:
          php-version: '7.2'
          coverage: none
          extensions: mbstring, intl

      - name: Set up Node
        uses: actions/setup-node@v1
        with:
          node-version: '14.x'

      - name: Setup Problem Matchers for PHPUnit
        run: echo "::add-matcher::${{ runner.tool_cache }}/phpunit.json"

      - name: Checkout code
        uses: actions/checkout@v3

      - name: Download dependencies
        run: composer update --no-interaction --no-progress --prefer-stable --prefer-lowest

      - name: Run tests
        run: make test

  build:
    name: Build
    runs-on: ubuntu-22.04
    strategy:
      max-parallel: 10
      matrix:
        php: ['7.2', '7.3', '7.4', '8.0', '8.1', '8.2']
        psr7: ['^1.9', '^2.4']
        include:
          - php: '8.0'
            psr7: '^1.9@dev'
          - php: '8.2'
            psr7: '^2.4@dev'
        exclude:
          - php: '8.1'
            psr7: '^1.9'
          - php: '8.2'
            psr7: '^1.9'

    steps:
      - name: Set up PHP
        uses: shivammathur/setup-php@v2
        with:
          php-version: ${{ matrix.php }}
          coverage: none
          extensions: mbstring, intl

      - name: Set up Node
        uses: actions/setup-node@v1
        with:
          node-version: '14.x'

      - name: Setup Problem Matchers for PHPUnit
        run: echo "::add-matcher::${{ runner.tool_cache }}/phpunit.json"

      - name: Checkout code
        uses: actions/checkout@v3

      - name: Download dependencies
        run: |
          composer require --no-update "guzzlehttp/psr7:${{ matrix.psr7 }}"
          composer update --no-interaction --no-progress

      - name: Run tests
        run: make test

  build-windows:
    name: Build on Windows
    runs-on: windows-2022
    strategy:
      max-parallel: 10
      matrix:
        php: ['7.2', '7.3', '7.4', '8.0', '8.1', '8.2']

    steps:
      - name: Set up PHP
        uses: shivammathur/setup-php@v2
        with:
          php-version: ${{ matrix.php }}
          coverage: none
          extensions: mbstring, intl

      - name: Set up Node
        uses: actions/setup-node@v1
        with:
          node-version: '14.x'

      - name: Setup Problem Matchers for PHPUnit
        run: echo "::add-matcher::${{ runner.tool_cache }}/phpunit.json"

      - name: Checkout code
        uses: actions/checkout@v3

      - name: Download dependencies
        run: composer update --no-interaction --no-progress

      - name: Start test servers
        shell: bash
        run: |
          node tests/server.js &
          ./vendor/bin/http_test_server &

      - name: Run tests
        run: vendor/bin/phpunit.bat
